From 55f4a27b52d593b90d35aebaea428b08a232d079 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Mon, 5 Dec 2011 09:38:20 -0600
Subject: Overriable support in library.

---
 lib/grade/grade_grade.php |    2 +-
 lib/grade/grade_item.php  |    8 +++++++-
 2 files changed, 8 insertions(+), 2 deletions(-)

diff --git a/lib/grade/grade_grade.php b/lib/grade/grade_grade.php
index 3278e7c..e6b6455 100644
--- a/lib/grade/grade_grade.php
+++ b/lib/grade/grade_grade.php
@@ -228,7 +228,7 @@ class grade_grade extends grade_object {
 
         $grade_item = $this->load_grade_item();
 
-        if ($grade_item->gradetype == GRADE_TYPE_NONE) {
+        if ($grade_item->gradetype == GRADE_TYPE_NONE or !$grade_item->is_overridable_item()) {
             return false;
         }
 
diff --git a/lib/grade/grade_item.php b/lib/grade/grade_item.php
index 630e915..12561f6 100644
--- a/lib/grade/grade_item.php
+++ b/lib/grade/grade_item.php
@@ -919,7 +919,13 @@ class grade_item extends grade_object {
      * @return boolean
      */
     public function is_overridable_item() {
-        return !$this->is_outcome_item() and ($this->is_external_item() or $this->is_calculated() or $this->is_course_item() or $this->is_category_item());
+        if ($this->is_course_item() or $this->is_category_item()) {
+            $overridable = (bool) get_config('moodle', 'grade_overridecat');
+        } else {
+            $overridable = true;
+        }
+
+        return !$this->is_outcome_item() and ($this->is_external_item() or $this->is_calculated() or $overridable);
     }
 
     /**
-- 
1.7.1


